#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "list.h"

list* create_empty_list(void) {
  list* l = (list*) malloc(sizeof(list));
  l->head = NULL;
  l->tail = NULL;
  return l;
}

int is_list_empty(list* l) {
  node* h = l->head;
  return (h == NULL);
}


void append_to_list(list* l, char* data) {
  node* n = (node*) malloc(sizeof(node));
  n->next = NULL;

  n->data = malloc(strlen(data)+1);
  strcpy(n->data, data);

  
  if(is_list_empty(l)) {
    l->head = n;
    l->tail = n;
  } else if (l->head == l->tail) {
    l->head->next = n;
    l->tail = n;
  } else {
    l->tail->next = n;
    l->tail = n;
  }
  
}

node* head(list* l) {
  node* h = l->head;
  return h;
}

node* tail(list* l) {
  return l->tail;
}


node* remove_head(list* l) {
  node* h = l->head;
  
  if(h != NULL) {
    l->head = h->next;
  } else {
    l->head = NULL;
  }

  if(l->tail == h) {
    l->tail = NULL;
  }
  return h;
}
