#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <pwd.h>
#include <grp.h>

int main(int argc, char ** argv) {
  char *cwd = NULL;
  DIR* dir_stream;
  struct dirent* dir_entry;
  struct stat stat_buffer;
  struct passwd* pwd_st;
  struct group* grp_st;
  char** members;

  /*
  if(argc < 2) {
    fprintf(stderr, "Usage %s [folder]+", argv[0]);
    exit(EXIT_FAILURE);
  }
  */
  
  cwd = getcwd(NULL, -1);
  
  if(cwd == NULL) {
    fprintf(stderr, "Accesso al nome della CWD fallito\n");
  } else {
    printf("Directory corrente (cwd) %s\n", cwd);
    printf("Lunghezza (in caratteri) del path: %lu\n", strlen(cwd));
  }
  
  dir_stream = opendir(cwd);

  if(dir_stream == NULL) {
    perror("Errore nell'accesso alla directory\n");
    exit(EXIT_FAILURE);
  }
  
  while( (dir_entry = readdir(dir_stream) ) != NULL) {
    stat(dir_entry->d_name, &stat_buffer);
    printf("File: %s (%lu bytes, %lu blocks)\n", dir_entry->d_name, (unsigned long) stat_buffer.st_size, (unsigned long) stat_buffer.st_blocks);
    printf("\tTipo di file: ");
    if(S_ISREG(stat_buffer.st_mode)) {
      printf("File regolare");
    } else if(S_ISDIR(stat_buffer.st_mode)) {
      printf("Directory");
    } else {
      printf("Altro");
    }

    printf("\n");

    
    pwd_st = getpwuid(stat_buffer.st_uid);
    
    if(pwd_st != NULL) 
      printf("\tProprietario: %s (%d)\n", pwd_st->pw_name, stat_buffer.st_uid);
    else 
      printf("\tProprietario: %d\n", stat_buffer.st_uid);

    
    grp_st = getgrgid(stat_buffer.st_gid);
    if(grp_st != NULL) {
      printf("\tGruppo: %s (%d)\n", grp_st->gr_name, stat_buffer.st_gid);
      printf("\tAltri utenti nel gruppo: ");
      members = grp_st->gr_mem;
      while(*members != NULL) {
	printf("%s ", *members);
	members++;
      }
      printf("\n");
    } else {
      printf("\tGruppo: %d\n", stat_buffer.st_gid);
    }
    
    printf("\tFile permissions. U: ");
    printf( ( stat_buffer.st_mode & S_IRUSR )? "r":"-");
    printf( ( stat_buffer.st_mode & S_IWUSR )? "w":"-");
    printf( ( stat_buffer.st_mode & S_IXUSR )? "x":"-");
    printf(" G: ");
    printf( ( stat_buffer.st_mode & S_IRGRP )? "r":"-");
    printf( ( stat_buffer.st_mode & S_IWGRP )? "w":"-");
    printf( ( stat_buffer.st_mode & S_IXGRP )? "x":"-");
    printf(" O: ");
    printf( ( stat_buffer.st_mode & S_IROTH )? "r":"-");
    printf( ( stat_buffer.st_mode & S_IWOTH )? "w":"-");
    printf( ( stat_buffer.st_mode & S_IXOTH )? "x":"-");
    printf("\n");
   

  } /* while on dir_stream */
  
  
  if(closedir(dir_stream))
    perror("Errore nella chiusura della directory.\n");
  

  exit(EXIT_SUCCESS);
}
